# NFT SDK for shared DApps

## How to use

##### Install the sdk

```shell
  npm install @renec-foundation/nft-sdk
  // or
  yarn add @renec-foundation/nft-sdk
```

##### Integrate

1. FetchNFT module
```js
import { FetchNFT } from "@renec-foundation/nft-sdk";
```

2. Fetch nft by wallet

```js
const connection = new Connection('https://api-mainnet-beta.renec.foundation:8899/')
const userAddress = new PublicKey('5SEXKYSvFCCRtHHQfNZW61AAFgiz5PF8vofnHyy5zRwR')
const NFTModule = new FetchNFT(connection, userAddress)
const nfts = await NFTModule.fetchNFTList();
```

3. Build transfer NFT transaction

```js
const connection = new Connection('https://api-mainnet-beta.renec.foundation:8899/')
const userAddress = new PublicKey('5SEXKYSvFCCRtHHQfNZW61AAFgiz5PF8vofnHyy5zRwR')
const NFTModule = new FetchNFT(connection, userAddress)
const buildTransaction = await NFTModule.buildTransferTransaction(
  "toAddress",
  "mintAddress"
);
```