/// <reference types=".pnpm/@solana+web3.js@1.31.0/node_modules/@solana/web3.js" />
import { Connection, PublicKey, Transaction } from "@solana/web3.js";
import { IFetchNFT, TNFTDetail } from "../types";
export declare const fetchNFTByWallet: (userAddress: string, connection: Connection, numberNFT?: number) => Promise<TNFTDetail[]>;
export declare const buildTransferNFTTransaction: (fromAddress: string, toAddress: string, mintAddress: string, connection: Connection) => Promise<Transaction>;
export declare class FetchNFT implements IFetchNFT {
    private connection;
    private userAddress;
    constructor(connection: Connection, userAddress: PublicKey);
    fetchNFTList: () => Promise<TNFTDetail[]>;
    buildTransferTransaction: (toAddress: string, mintAddress: string) => Promise<Transaction | undefined>;
}
